/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: NGObjCRuntime.h,v 1.2 2003/07/11 17:12:50 jan Exp $

#ifndef __NGExtensions_NGObjCRuntime_H__
#define __NGExtensions_NGObjCRuntime_H__

#import <Foundation/NSObject.h>

@class NSString, NSArray, NSEnumerator;

@interface NSObject(NGObjCRuntime)

/* retrieving additional class info */

+ (unsigned)instanceSize;

/* adding methods to a class */

+ (void)addMethods:(SEL)_selector, ...;
+ (void)addClassMethods:(SEL)_selector, ...;

+ (NSEnumerator *)methodNameEnumerator;
+ (NSEnumerator *)hierachyMethodNameEnumerator;

/* making a subclass of a class */

+ (Class)subclass:(NSString *)_className ivars:(NSString *)_name1,...;

/* instance variables */

+ (NSArray *)instanceVariableNames;
+ (NSArray *)allInstanceVariableNames;
+ (BOOL)hasInstanceVariableWithName:(NSString *)_ivarName;
+ (NSString *)signatureOfInstanceVariableWithName:(NSString *)_ivarName;
+ (unsigned)offsetOfInstanceVariableWithName:(NSString *)_ivarName;

@end

#endif /* __NGExtensions_NGObjCRuntime_H__ */
