/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: NGQuotedPrintableCoding.h,v 1.3 2003/07/11 17:12:50 jan Exp $

#ifndef __NGExtensions_NGQuotedPrintableCoding_H__
#define __NGExtensions_NGQuotedPrintableCoding_H__

#import <Foundation/NSString.h>
#import <Foundation/NSData.h>
#include <NGExtensions/NGExtensionsDecls.h>

/*
  Quoted Printable encoder/decoder

  As specified in RFC 822
*/

@interface NSString(QuotedPrintableCoding)

- (NSString *)stringByDecodingQuotedPrintable;
- (NSString *)stringByEncodingQuotedPrintable;

@end

@interface NSData(QuotedPrintableCoding)

/*
  Decode a quoted printable encoded data. Returns nil if decoding failed.
*/
- (NSData *)dataByDecodingQuotedPrintable;

/*
  Decode data in quoted printable encoding. Returns nil if encoding failed.
*/
- (NSData *)dataByEncodingQuotedPrintable;

@end

NGExtensions_EXPORT int
NGEncodeQuotedPrintable(const char *_src, unsigned _srcLen,
                        char *_dest, unsigned _destLen);
NGExtensions_EXPORT int
NGDecodeQuotedPrintable(const char *_src, unsigned _srcLen,
                        char *_dest, unsigned _destLen);

#endif /* __NGExtensions_NGQuotedPrintableCoding_H__ */
