/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: NSArray+enumerator.h,v 1.3 2003/07/11 17:12:50 jan Exp $

#ifndef __NGExtensions_NSArray_enumerator_H__
#define __NGExtensions_NSArray_enumerator_H__

#import <Foundation/NSArray.h>

@class NSSet;

@interface NSArray(enumerator)

- (id)initWithObjectsFromEnumerator:(NSEnumerator *)_enumerator;

/*
  Returns an array contructed using this algorithm:

    for (i = 0; i < [self count]; i++)
      newArray[i] = [array[i] performSelector:_selector];

  If the selector returns nil, NSNull is placed in the resulting array.
*/
- (NSArray *)mappedArrayUsingSelector:(SEL)_selector;
- (NSArray *)mappedArrayUsingSelector:(SEL)_selector withObject:(id)_object;
- (NSSet *)mappedSetUsingSelector:(SEL)_selector;
- (NSSet *)mappedSetUsingSelector:(SEL)_selector withObject:(id)_object;

@end

@interface NSMutableArray(enumerator);

- (id)initWithObjectsFromEnumerator:(NSEnumerator *)_enumerator;

@end

#endif /* __NGExtensions_NSArray_enumerator_H__ */
