/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: iCalEntityObject.h,v 1.3 2003/07/18 15:01:10 martin Exp $

#ifndef __NGiCal_iCalEntityObject_H__
#define __NGiCal_iCalEntityObject_H__

#include <NGiCal/iCalObject.h>

/*
  iCalEntityObject
  
  This is a common base class for tasks and appointments which share a lot of
  attributes.
*/

@class NSCalendarDate, NSMutableArray, NSString, NSArray;
@class iCalPerson;

@interface iCalEntityObject : iCalObject
{
  NSString       *uid;
  NSString       *summary;
  NSTimeInterval timestamp;
  NSCalendarDate *created;
  NSCalendarDate *lastModified;
  NSCalendarDate *startDate;
  NSString       *accessClass;
  NSString       *priority;
  NSMutableArray *alarms;
  iCalPerson     *organizer;
  NSMutableArray *attendees;
  NSString       *comment;
  NSString       *sequence;
  NSString       *location;
}

/* accessors */

- (void)setUid:(NSString *)_value;
- (NSString *)uid;

- (void)setSummary:(NSString *)_value;
- (NSString *)summary;

- (void)setLocation:(NSString *)_value;
- (NSString *)location;

- (void)setComment:(NSString *)_value;
- (NSString *)comment;

- (void)setTimeStampAsDate:(NSCalendarDate *)_date;
- (NSCalendarDate *)timeStampAsDate;

- (void)setStartDate:(NSCalendarDate *)_date;
- (NSCalendarDate *)startDate;

- (void)setLastModified:(NSCalendarDate *)_value;
- (NSCalendarDate *)lastModified;

- (void)setCreated:(NSCalendarDate *)_value;
- (NSCalendarDate *)created;

- (void)setAccessClass:(NSString *)_value;
- (NSString *)accessClass;

- (void)setPriority:(NSString *)_value;
- (NSString *)priority;

- (void)setSequence:(NSString *)_value;
- (NSString *)sequence;

- (void)setOrganizer:(iCalPerson *)_organizer;
- (iCalPerson *)organizer;

- (void)addToAttendees:(iCalPerson *)_person;
- (NSArray *)attendees;

- (void)addToAlarms:(id)_alarm;
- (NSArray *)alarms;
- (BOOL)hasAlarms;

@end

#endif /* __NGiCal_iCalEntityObject_H__ */
