/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: iCalToDo.h,v 1.3 2003/07/18 15:01:10 martin Exp $

#ifndef __NGiCal_iCalToDo_H__
#define __NGiCal_iCalToDo_H__

#include <NGiCal/iCalEntityObject.h>

/*
  iCalToDo
  
  This class keeps the attributes of an iCalendar todo record (a task).
*/

@class NSString, NSCalendarDate;

@interface iCalToDo : iCalEntityObject
{
  NSCalendarDate *due;
  NSString       *percentComplete;
  NSCalendarDate *completed;
}

- (void)setPercentComplete:(NSString *)_value;
- (NSString *)percentComplete;

- (void)setDue:(NSCalendarDate *)_date;
- (NSCalendarDate *)due;

- (void)setCompleted:(NSCalendarDate *)_date;
- (NSCalendarDate *)completed;

@end

#endif /* __NGiCal_iCalToDo_H__ */
